HDU 4776 Ants(Trie+优先队列)
Ants
Time Limit: 20000/10000 MS (Java/Others) Memory Limit: 327680/327680 K (Java/Others)
Total Submission(s): 1324 Accepted Submission(s): 289
Now in the farm come a lot of ants, which are going to enjoy the delicious apples. The ants climb the tree one by one. Every ant would choose a node as the starting node and another node as the ending node, then it would crawl alone the unique path from the starting node to the ending node. The distance between two nodes is defined as the XOR sum of lengths of all the edges in the unique path between them. Every ant wants to crawl along such a path which the distance is as large as possible. But two ants cannot crawl from the same starting node to the same ending node. You should calculate the distance which the k-th ant crawled.
Note that the starting node and the ending node cannot be the same for an ant.
For each test case, the first line contain an integer n denoting the number of nodes.
The next n-1 lines each contains three integers x,y,z, denoting that there exists an edge between node x and node y and its length is z. The nodes are numbered from 1 to n.
The next line contain a integer m denoting the number of queries.
In the next m lines, each line contains an integer k denoting that you need to calculate the distance of the k-th ant.
The input ends with n = 0.
(1 <= n, m <= 100000, 1 <= x, y <= n, 0 <= z <= 1018, 1 <= k <= 200000)
In the first test case, the first ant may crawl from node 2 to node 3, and the second ant may crawl from node 3 to node 2, and the 5-th ant may crawl from node 1 to node 3.
The distance of the 5-th ant can be calculated by 2 xor 3 = 1.
题目链接:HDU 4776
题意就是求第K大路径异或值,那很容易想到用前缀和的思想把一条路径的异或值用DFS转换成$val[u]\oplus val[v]$,其中$val[i]$是从根节点到$i$节点的路径异或和,那么题目就变成了给定大小为N个数列$val[]$,求第K大的两两异或值$val[i]\oplus val[j]$。可以先从第1大开始求,第1大很简单,对于所有的$val[i]$,找出它能异或出的最大值$val[i]\oplus val[j]$,那么这些最大值序列中全局最大的就是第1大的值,然后考虑第2大,可以发现第2大只能来自两种情况:第1大的值对应的节点下第2大的值或者是就是原来求第1大的时候第2大的值,而第3、第4大其本身和后面的迭代结果不会成为当前的第2大,因为目前的第2大已经比后面的数都大了,对于一个节点$u$,每一次去找它的第$k+1$大的值,数值必定是递减的也就是说$真实的第k大 \ge 迭代x次的第k大$,既然每一次迭代会变小,那么迭代1次总可以得到最大可能的第k大就是真实的第k大;然后就是不停地取出当前的最大值,去更新,如果这个节点更新的次数超过$n-1$次,那么就不能再更新了,因为它最多和$n-1$个数组合,即最多拥有$n-1$个异或值。
那如何用Trie求某个数的第k大的异或值呢,用主席树的思想,看当前节点的反方向子节点下的节点数是否大于等于k,如果大于等于k则可以往反方向走,否则只能正着走并用k减去节点个数
可以参照这个图理解:
代码:
- #include <stdio.h>
- #include <iostream>
- #include <algorithm>
- #include <cstdlib>
- #include <cstring>
- #include <bitset>
- #include <string>
- #include <stack>
- #include <cmath>
- #include <queue>
- #include <set>
- #include <map>
- using namespace std;
- #define INF 0x3f3f3f3f
- #define LC(x) (x<<1)
- #define RC(x) ((x<<1)+1)
- #define MID(x,y) ((x+y)>>1)
- #define fin(name) freopen(name,"r",stdin)
- #define fout(name) freopen(name,"w",stdout)
- #define CLR(arr,val) memset(arr,val,sizeof(arr))
- #define FAST_IO ios::sync_with_stdio(false);cin.tie(0);
- typedef pair<int, int> pii;
- typedef long long LL;
- const double PI = acos(-1.0);
- const int N = 100010;
- struct edge
- {
- int to, nxt;
- LL v;
- edge() {}
- edge(int _to, int _nxt, LL _v): to(_to), nxt(_nxt), v(_v) {}
- } E[N << 1];
- struct Trie
- {
- int nxt[2];
- int cnt;
- LL v;
- void init()
- {
- nxt[0] = nxt[1] = 0;
- cnt = 0;
- v = 0;
- }
- } L[N * 61];
- struct info
- {
- int k;
- LL val;
- LL Max_xor_val;
- bool operator<(const info &rhs)const
- {
- return Max_xor_val < rhs.Max_xor_val;
- }
- };
- int head[N], tot;
- LL arr[N];
- int sz;
- int n, m;
- priority_queue<info>Q;
- pii query[N << 1];
- LL ans[N << 1];
- void init()
- {
- CLR(head, -1);
- tot = 0;
- sz = 1;
- L[0].init();
- while (Q.size())
- Q.pop();
- }
- inline void add(int s, int t, LL d)
- {
- E[tot] = edge(t, head[s], d);
- head[s] = tot++;
- }
- void dfs(int u, int f, LL sum)
- {
- arr[u] = sum;
- for (int i = head[u]; ~i; i = E[i].nxt)
- {
- int v = E[i].to;
- if (v != f)
- dfs(v, u, sum ^ E[i].v);
- }
- }
- void Insert(LL val)
- {
- int u = 0;
- for (int i = 60; i >= 0; --i)
- {
- int v = (val >> i) & 1;
- if (!L[u].nxt[v])
- {
- L[sz].init();
- L[u].nxt[v] = sz++;
- }
- u = L[u].nxt[v];
- ++L[u].cnt;
- }
- L[u].v = val;
- }
- LL getKth(LL val, int k)
- {
- if (k > n - 1)
- return -1;
- int u = 0;
- for (int i = 60; i >= 0; --i)
- {
- int v = (val >> i) & 1;
- int cnt = L[L[u].nxt[v ^ 1]].cnt;
- if (cnt >= k)
- u = L[u].nxt[v ^ 1];
- else
- {
- k -= cnt;
- u = L[u].nxt[v];
- }
- }
- return val ^ L[u].v;
- }
- int main(void)
- {
- int u, v, i;
- LL x;
- while (~scanf("%d", &n) && n)
- {
- init();
- for (i = 1; i < n; ++i)
- {
- scanf("%d%d%I64d", &u, &v, &x);
- add(u, v, x);
- add(v, u, x);
- }
- scanf("%d", &m);
- for (i = 0; i < m; ++i)
- {
- scanf("%d", &query[i].first);
- query[i].second = i;
- }
- sort(query, query + m);
- dfs(1, -1, 0LL);
- for (i = 1; i <= n; ++i)
- Insert(arr[i]);
- for (i = 1; i <= n; ++i)
- {
- LL Max_xor_val = getKth(arr[i], 1);
- if (~Max_xor_val)
- Q.push({1, arr[i], Max_xor_val});
- }
- int Rank = 1;
- for (i = 0; i < m; ++i)
- {
- while (!Q.empty() && Rank < query[i].first)//每次取最大的节点进行扩展
- {
- info now = Q.top();
- Q.pop();
- ++now.k;
- LL Max_xor_val = getKth(now.val, now.k);
- if (~Max_xor_val)
- {
- now.Max_xor_val = Max_xor_val;
- Q.push(now);
- }
- ++Rank;
- }
- if (!Q.empty())
- ans[query[i].second] = Q.top().Max_xor_val;
- else
- ans[query[i].second] = -1;
- }
- for (i = 0; i < m; ++i)
- printf("%I64d\n", ans[i]);
- }
- return 0;
- }
HDU 4776 Ants(Trie+优先队列)的更多相关文章
- HDU 4857 拓扑排序 优先队列
n个数,已经有大小关系,现给m个约束,规定a在b之前,剩下的数要尽可能往前移.输出序列 大小关系显然使用拓扑结构,关键在于n个数本身就有大小关系,那么考虑反向建图,优先选择值最大的入度为零的点,这样得 ...
- HDU 4857 逃生 (优先队列+反向拓扑)
题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4857 解题报告:有n个点,有m个条件限制,限制是像这样的,输入a b,表示a必须排在b的前面,如果不 ...
- HDU 1242 (BFS搜索+优先队列)
题目链接: http://acm.hdu.edu.cn/showproblem.php?pid=1242 题目大意:多个起点到一个终点,普通点耗时1,特殊点耗时2,求到达终点的最少耗时. 解题思路: ...
- HDU 5638 拓扑排序+优先队列
题目链接: http://acm.hdu.edu.cn/showproblem.php?pid=5638 题意: 给你一个DAG图,删除k条边,使得能个得到字典序尽可能小的拓扑排序 题解: 把拓扑排序 ...
- HDU4776 Ants(Trie && xor)
之前mark下来的一道题,今天填一下坑. 题意是这样子的.给你一棵边上有权的树.然后有树上两点(u,v)的路径有n*(n-1)条,路径(u,v)的权值是边权的xor. 然后下面有m个询问,询问你n*( ...
- hdu - 1242 Rescue && hdu - 2425 Hiking Trip (优先队列+bfs)
http://acm.hdu.edu.cn/showproblem.php?pid=1242 感觉题目没有表述清楚,angel的朋友应该不一定只有一个,那么正解就是a去搜索r,再用普通的bfs就能过了 ...
- HDU 1242 Rescue(优先队列)
题目来源: http://acm.hdu.edu.cn/showproblem.php?pid=1242 题目描述: Problem Description Angel was caught by ...
- HDU 1242 Rescue(BFS+优先队列)
题目链接: http://acm.hdu.edu.cn/showproblem.php?pid=1242 题目描述: Problem Description Angel was caught by t ...
- HDU 2296 Ring ( Trie图 && DP && DP状态记录)
题意 : 给出 m 个单词,每一个单词有一个权重,如果一个字符串包含了这些单词,那么意味着这个字符串拥有了其权重,问你构成长度为 n 且权重最大的字符串是什么 ( 若有权重相同的,则输出最短且字典序最 ...
随机推荐
- Java OOP——第二章 继承
1. 继承: ●继承是面向对象的三大特征之一,是JAVA实现代码重用的重要手段之一: ●继承是代码重用的一种方式,将子类共有的属性和行为放到父类中: ●JAVA只支持单继承,即每一个类只有一个父类,继 ...
- 【vlan之四种方式链路认证组网]
---恢复内容开始--- 根据项目需求,搭建好如下拓扑图: 在[sysname]下配置给予协议的vlan vlan 1#vlan 10 protocol-vlan 0 ipv4#vlan 20 pro ...
- 【ospf-路由过滤】
- Mysql基础3-数据操作语言DML-数据查询语言DQL
主要: 数据操作语言DML 数据查询语言DQL 数据操作语言DML DML: Data Mutipulation Language 插入数据(增) 一般插入数据形式 1)形式1: insert [in ...
- python并发编程之多进程、多线程、异步、协程、通信队列Queue和池Pool的实现和应用
什么是多任务? 简单地说,就是操作系统可以同时运行多个任务.实现多任务有多种方式,线程.进程.协程. 并行和并发的区别? 并发:指的是任务数多余cpu核数,通过操作系统的各种任务调度算法,实现用多个任 ...
- labview在编写程序框图中遇到的一些布尔按钮控制布尔指示灯问题
上图布尔控件按下,数据0x04成功发送给下位机,布尔灯不亮. ............... ............. ........... 下图布尔控件按下, ...
- SQL Server附加数据库拒绝访问错误解决方法
今天在MsSQL里附加数据库时提示操作系统错误5(拒绝访问),这里我没给出了两个解决方案供大家解决问题. 方案一:切换登录方式 出现这种情况是由于用“混合验证方式”(SQL Server身份验证)登录 ...
- OpenCV代码提取:transpose函数的实现
OpenCV中的transpose函数实现图像转置,公式为: 目前fbc_cv库中也实现了transpose函数,支持多通道,uchar和float两种数据类型,经测试,与OpenCV3.1结果完全一 ...
- 从一个线上服务器警告谈谈backlog
缘起 双十一如期而至,此时的我因为在处理客户的一个问题已经陷入了忙碌.突然,不断接到驻场实施发来的反馈,都是相同的反馈--"客户端操作缓慢". 我现在负责的服务器是一台接口服务器, ...
- 汇编指令MOVSX与MOVZX
MOVSX 操作数A ,操作数B MOVZX 操作数A ,操作数B 相同点:操作数B 空间必须小于 操作数A 1.格式与MOV基本相同 2.能完成小存储单元向大存储单元的数据传送 比如 movsx e ...